SystemOrganization addCategory: #'Croquis-sub operation'!
SystemOrganization addCategory: #'Croquis-main'!

Object subclass: #CClassChooser
	instanceVariableNames: 'classes chosen ifNoClass ifDidNotChoose title ifChosen'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquis-sub operation'!

!CClassChooser classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/7/2012 13:23'!
from: anArray ifNoClass: aBlockClosure ifDidNotChoose: aBlockClosure3 
	^self from: anArray title: 'Choose a class' ifNoClass: aBlockClosure ifDidNotChoose: aBlockClosure3 ! !

!CClassChooser classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/7/2012 13:33'!
from: anArray title: aString ifNoClass: aBlockClosure ifDidNotChoose: aBlockClosure3 
	^self from: anArray title: aString ifNoClass: aBlockClosure ifDidNotChoose: aBlockClosure3 ifChosen: [:chosen| chosen] ! !

!CClassChooser classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/7/2012 13:30'!
from: anArray title: aString ifNoClass: aBlockClosure ifDidNotChoose: aBlockClosure4 ifChosen: aBlockClosure5 
	^self new
		classes: anArray;
		title: aString;
		ifNoClass: aBlockClosure;
		ifDidNotChoose: aBlockClosure4 ;
		ifChosen: aBlockClosure5;
		answerAClass! !

!CClassChooser methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/7/2012 13:31'!
answerAClass

	classes isEmpty
		ifTrue: [ ^ifNoClass value ].
	chosen := UIManager default chooseFrom: (classes collect: #name) values: classes title: title.
	chosen ifNil: [ ^ifDidNotChoose value ].
	^ifChosen value: chosen.! !

!CClassChooser methodsFor: 'accessing' stamp: 'HwaJong 12/7/2012 13:12'!
chosen
	^ chosen! !

!CClassChooser methodsFor: 'accessing' stamp: 'HwaJong 12/7/2012 13:12'!
classes
	^ classes! !

!CClassChooser methodsFor: 'accessing' stamp: 'HwaJong 12/7/2012 13:12'!
classes: anObject
	classes := anObject! !

!CClassChooser methodsFor: 'accessing' stamp: 'HwaJong 12/7/2012 13:30'!
ifChosen: aBlockClosure 
	ifChosen := aBlockClosure ! !

!CClassChooser methodsFor: 'accessing' stamp: 'HwaJong 12/7/2012 13:14'!
ifDidNotChoose: aBlockClosure 
	ifDidNotChoose := aBlockClosure ! !

!CClassChooser methodsFor: 'accessing' stamp: 'HwaJong 12/7/2012 13:14'!
ifNoClass: aBlockClosure 
ifNoClass := aBlockClosure 
! !

!CClassChooser methodsFor: 'accessing' stamp: 'HwaJong 12/7/2012 13:20'!
title
	^ title! !

!CClassChooser methodsFor: 'accessing' stamp: 'HwaJong 12/7/2012 13:20'!
title: aString
	title := aString! !

Object subclass: #CreateClassFromNoun
	instanceVariableNames: 'words className englishNoun croquis'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquis-sub operation'!

!CreateClassFromNoun methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/5/2012 02:55'!
correctClassNamePluralToSingular
	croquis correctPluralToSingular
		ifTrue: [ 
			(words last endsWith: 'ies')
				ifTrue: [ words at: words size modify: [ :str | (str allButLast:3) , 'y' ] ].
			(words last endsWith: 's')
				ifTrue: [ words at: words size modify: [ :str | str allButLast ] ] ]! !

!CreateClassFromNoun methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/5/2012 02:55'!
createClass
	croquis privateCreateOnSuperclassWithClassName: className.! !

!CreateClassFromNoun methodsFor: 'accessing' stamp: 'HwaJong 12/5/2012 02:55'!
croquis: aCroquis
	croquis := aCroquis! !

!CreateClassFromNoun methodsFor: 'accessing' stamp: 'HwaJong 12/5/2012 00:15'!
englishNoun: bString
	englishNoun := bString! !

!CreateClassFromNoun methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/5/2012 00:18'!
informClassAlreayExist
	^ UIManager default
		inform:
			className surroundedBySingleQuotes
				,
					' already exists.
Process aborted.'! !

!CreateClassFromNoun methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/5/2012 02:55'!
runo
	self setWordsFromEnglishNoun.
	self correctClassNamePluralToSingular.
	self setClassNameFromWords.
	(Smalltalk hasClassNamed: className)
		ifTrue: [ ^ self informClassAlreayExist ].
	croquis chooseSuperclassFromOutputSystemCategoryForClassName: className.
	self createClass! !

!CreateClassFromNoun methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/5/2012 00:24'!
setClassNameFromWords
	className := (String
		streamContents: [ :stream | (words collect: #capitalized) do: [ :each | stream nextPutAll: each ] ]) asSymbol! !

!CreateClassFromNoun methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/5/2012 01:38'!
setWordsFromEnglishNoun
	words := englishNoun subStrings: ' -	.,''"!!?():;'! !

Object subclass: #Croquis
	instanceVariableNames: 'superclassOfOutputClass correctPluralToSingular outputSystemCategory asksUserToManuallyChooseSuperclassOfOutputClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquis-main'!

!Croquis methodsFor: 'accessing' stamp: 'HwaJong 12/5/2012 02:41'!
asksUserToManuallyChooseSuperclassOfOutputClass
	^ asksUserToManuallyChooseSuperclassOfOutputClass! !

!Croquis methodsFor: 'accessing' stamp: 'HwaJong 12/5/2012 02:41'!
asksUserToManuallyChooseSuperclassOfOutputClass: aBoolean
	asksUserToManuallyChooseSuperclassOfOutputClass := aBoolean! !

!Croquis methodsFor: 'private' stamp: 'HwaJong 12/7/2012 13:34'!
chooseSuperclassFromOutputSystemCategoryForClassName: aString
	self asksUserToManuallyChooseSuperclassOfOutputClass
		ifTrue: [ 
			CClassChooser from: (self classesInTheOutputSystemCategory , {Object})
				title: 'Superclass of ' , aString
				ifNoClass: [self error: 'no class to choose!!']
				ifDidNotChoose: []
				ifChosen: [:class| self superclassOfOutputClass: class ] ]! !

!Croquis methodsFor: 'accessing' stamp: 'HwaJong 12/1/2012 20:45'!
classesInTheOutputSystemCategory
	^ (((PackageInfo named: self outputSystemCategory) classes) asSortedCollection: [:class1 :class2| class1 name <= class2 name ]) asArray! !

!Croquis methodsFor: 'accessing' stamp: 'HwaJong 12/5/2012 02:41'!
correctPluralToSingular
	^ correctPluralToSingular! !

!Croquis methodsFor: 'accessing' stamp: 'HwaJong 12/5/2012 02:41'!
correctPluralToSingular: aBoolean
	correctPluralToSingular := aBoolean! !

!Croquis methodsFor: 'create class' stamp: 'HwaJong 12/5/2012 00:33'!
createClassFromClipboardText
	self createClassFromNoun: Clipboard clipboardText asString! !

!Croquis methodsFor: 'create class' stamp: 'HwaJong 12/5/2012 02:54'!
createClassFromNoun: aString
	| ccf |
	self outputSystemCategory isString
		ifFalse: [ self error: 'Need to set outputSystemCategory to continue.' ].
	ccf := CreateClassFromNoun new.
	ccf croquis: self.
	ccf englishNoun: aString.
	ccf runo.
	! !

!Croquis methodsFor: 'create class' stamp: 'HwaJong 12/1/2012 17:02'!
createClassFromUser
	| noun |
	noun := UIManager default request: 'plain english noun to create class:'.
	noun ifNil: [^self].
	noun isEmpty ifTrue: [^self inform: 'You did not enter anything.
Aborting process.'].
	self createClassFromNoun: noun.! !

!Croquis methodsFor: 'initialize-release' stamp: 'HwaJong 12/5/2012 02:41'!
initialize
	super initialize.
	superclassOfOutputClass := Object.
	correctPluralToSingular := false.
	outputSystemCategory := nil.
	asksUserToManuallyChooseSuperclassOfOutputClass := false! !

!Croquis methodsFor: 'move class' stamp: 'HwaJong 12/5/2012 02:42'!
moveClassByUser
	MoveClassFromUserToUser new
		croquis: self;
		goNow.! !

!Croquis methodsFor: 'move class' stamp: 'HwaJong 12/5/2012 02:42'!
moveClassToSuperclassByUser
	MoveClassFromUserToLastSuperclass new
		croquis: self;
		goNow.
! !

!Croquis methodsFor: 'move class' stamp: 'HwaJong 12/6/2012 11:50'!
moveClassesByNameRule
	self moveClassesByNameRule: self classesInTheOutputSystemCategory! !

!Croquis methodsFor: 'move class' stamp: 'HwaJong 12/6/2012 12:12'!
moveClassesByNameRule: anArray 
	| nameLengthSortedClasses shortestNameClass longerNameClasses longerNameThatContainsShortestNameClasses |
	anArray isEmpty ifTrue: [^self].
	nameLengthSortedClasses := anArray asSortedCollection: [:a :b| a name size <= b name size].
	shortestNameClass := nameLengthSortedClasses first.
	longerNameClasses := nameLengthSortedClasses allButFirst.
	longerNameThatContainsShortestNameClasses := longerNameClasses select: [:each| (each name indexOfSubCollection: shortestNameClass name) > 0 ].
	longerNameThatContainsShortestNameClasses do: [:each| each moveToSuperclassNamed: shortestNameClass name].
	self moveClassesByNameRule: longerNameThatContainsShortestNameClasses.
	self moveClassesByNameRule: (longerNameClasses copyWithoutAll: longerNameThatContainsShortestNameClasses).! !

!Croquis methodsFor: 'accessing' stamp: 'HwaJong 12/5/2012 02:41'!
outputSystemCategory
	^ outputSystemCategory! !

!Croquis methodsFor: 'accessing' stamp: 'HwaJong 12/1/2012 15:16'!
outputSystemCategory: aString 
	outputSystemCategory := aString! !

!Croquis methodsFor: 'private' stamp: 'HwaJong 12/5/2012 02:53'!
privateCreateOnSuperclassWithClassName: aSymbol 
	self superclassOfOutputClass
		subclass: aSymbol
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: self outputSystemCategory! !

!Croquis methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/8/2012 15:05'!
renameClassFromUser

	| classToRename newName |
	classToRename := CClassChooser
		from: self classesInTheOutputSystemCategory
		title: 'class to rename'
		ifNoClass: [ self error: 'No class to rename' ]
		ifDidNotChoose: [ self error: 'Interrupted by not choosing class to rename ...' ].
		
	newName := UIManager default request: 'rename to what?' initialAnswer: (classToRename name) centerAt: ActiveHand position.
	newName isNil ifTrue: [self error: 'user refused to enter a new name.'].
	newName isEmpty ifTrue: [self error: 'nothing entered.'].
	(Smalltalk hasClassNamed: newName) ifTrue: [self error: 'class of that name is already existing.'].
	classToRename rename: newName.! !

!Croquis methodsFor: 'accessing' stamp: 'HwaJong 12/7/2012 13:43'!
setSuperclassOfOutputClassFromUser
	CClassChooser
		from: self classesInTheOutputSystemCategory
		title: 'superclass of output class'
		ifNoClass: [ self error: 'No class to move' ]
		ifDidNotChoose: [ self error: 'Interrupted by not choosing class to move ...' ]
		ifChosen: [ :class | superclassOfOutputClass := class ]! !

!Croquis methodsFor: 'accessing' stamp: 'HwaJong 12/5/2012 02:41'!
superclassOfOutputClass
	^ superclassOfOutputClass! !

!Croquis methodsFor: 'accessing' stamp: 'HwaJong 12/5/2012 02:41'!
superclassOfOutputClass: aClass
	superclassOfOutputClass := aClass! !

Object subclass: #MoveClassOp
	instanceVariableNames: 'croquis classToMove movableClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquis-sub operation'!

MoveClassOp subclass: #MoveClassFromUserToLastSuperclass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquis-sub operation'!

!MoveClassFromUserToLastSuperclass methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/5/2012 02:29'!
movableClasses
	^ croquis classesInTheOutputSystemCategory
		copyWithoutAll: {(croquis superclassOfOutputClass)} , croquis superclassOfOutputClass subclasses! !

!MoveClassFromUserToLastSuperclass methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/5/2012 02:38'!
superclassToSit
	^ croquis superclassOfOutputClass! !

MoveClassOp subclass: #MoveClassFromUserToUser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquis-sub operation'!

!MoveClassFromUserToUser methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/5/2012 02:29'!
movableClasses
	^ croquis classesInTheOutputSystemCategory! !

!MoveClassFromUserToUser methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/7/2012 13:46'!
superclassToSit
	^ CClassChooser
		from:
			(((movableClasses copyWithoutAll: classToMove withAllSubclasses) , {Object} copyWithout: classToMove superclass)
				copyWithout: classToMove superclass)
		title: 'to superclass:'
		ifNoClass: [ self error: 'No class to be superclass' ]
		ifDidNotChoose: [  ]
		ifChosen: [ :class | class ]! !

!MoveClassOp methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/7/2012 13:39'!
classToMove
	movableClasses := self movableClasses.
	^CClassChooser 
		from: movableClasses
		title: 'class to move:' 
		ifNoClass: [ self error: 'No class to move' ] 
		ifDidNotChoose: [ self error: 'Interrupted by not choosing class to move ...' ]
		ifChosen: [:class| classToMove := class ]! !

!MoveClassOp methodsFor: 'accessing' stamp: 'HwaJong 12/5/2012 02:18'!
croquis
	^ croquis! !

!MoveClassOp methodsFor: 'accessing' stamp: 'HwaJong 12/5/2012 02:18'!
croquis: aCroquis
	croquis := aCroquis
! !

!MoveClassOp methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/5/2012 02:57'!
goNow
	(Smalltalk classNamed: self classToMove name) moveToSuperclassNamed: self superclassToSit name! !
